#ifndef _H_1D414E8258A3157ACB5F18AB81DBFCD7_Synthesizer__H_
#define _H_1D414E8258A3157ACB5F18AB81DBFCD7_Synthesizer__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace tts_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  Synthesizer_Request_
            {
                ::DDS::String_mgr text_;
                ::DDS::String_mgr metadata_;
            };

            typedef DDS_DCPSStruct_var<Synthesizer_Request_> Synthesizer_Request__var;
            typedef DDS_DCPSStruct_out < Synthesizer_Request_> Synthesizer_Request__out;

            struct  Synthesizer_Response_
            {
                ::DDS::String_mgr result_;
            };

            typedef DDS_DCPSStruct_var<Synthesizer_Response_> Synthesizer_Response__var;
            typedef DDS_DCPSStruct_out < Synthesizer_Response_> Synthesizer_Response__out;

            struct  Sample_Synthesizer_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::tts_interfaces::srv::dds_::Synthesizer_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Synthesizer_Request_> Sample_Synthesizer_Request__var;
            typedef DDS_DCPSStruct_out < Sample_Synthesizer_Request_> Sample_Synthesizer_Request__out;

            struct  Sample_Synthesizer_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::tts_interfaces::srv::dds_::Synthesizer_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Synthesizer_Response_> Sample_Synthesizer_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Synthesizer_Response_> Sample_Synthesizer_Response__out;

        }

    }

}

#endif /* _H_1D414E8258A3157ACB5F18AB81DBFCD7_Synthesizer__H_ */
