// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tts_interfaces:srv/Polly.idl
// generated code does not contain a copyright notice

#ifndef TTS_INTERFACES__SRV__POLLY__STRUCT_H_
#define TTS_INTERFACES__SRV__POLLY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'polly_action'
// Member 'text'
// Member 'text_type'
// Member 'language_code'
// Member 'voice_id'
// Member 'output_format'
// Member 'output_path'
// Member 'sample_rate'
// Member 'lexicon_content'
// Member 'lexicon_name'
// Member 'lexicon_names'
// Member 'speech_mark_types'
// Member 'next_token'
// Member 'sns_topic_arn'
// Member 'task_id'
// Member 'task_status'
// Member 'output_s3_bucket_name'
// Member 'output_s3_key_prefix'
#include "rosidl_generator_c/string.h"

// Struct defined in srv/Polly in the package tts_interfaces.
typedef struct tts_interfaces__srv__Polly_Request
{
  rosidl_generator_c__String polly_action;
  rosidl_generator_c__String text;
  rosidl_generator_c__String text_type;
  rosidl_generator_c__String language_code;
  rosidl_generator_c__String voice_id;
  rosidl_generator_c__String output_format;
  rosidl_generator_c__String output_path;
  rosidl_generator_c__String sample_rate;
  rosidl_generator_c__String lexicon_content;
  rosidl_generator_c__String lexicon_name;
  rosidl_generator_c__String__Sequence lexicon_names;
  rosidl_generator_c__String__Sequence speech_mark_types;
  uint32_t max_results;
  rosidl_generator_c__String next_token;
  rosidl_generator_c__String sns_topic_arn;
  rosidl_generator_c__String task_id;
  rosidl_generator_c__String task_status;
  rosidl_generator_c__String output_s3_bucket_name;
  rosidl_generator_c__String output_s3_key_prefix;
  bool include_additional_language_codes;
} tts_interfaces__srv__Polly_Request;

// Struct for a sequence of tts_interfaces__srv__Polly_Request.
typedef struct tts_interfaces__srv__Polly_Request__Sequence
{
  tts_interfaces__srv__Polly_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tts_interfaces__srv__Polly_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "rosidl_generator_c/string.h"

// Struct defined in srv/Polly in the package tts_interfaces.
typedef struct tts_interfaces__srv__Polly_Response
{
  rosidl_generator_c__String result;
} tts_interfaces__srv__Polly_Response;

// Struct for a sequence of tts_interfaces__srv__Polly_Response.
typedef struct tts_interfaces__srv__Polly_Response__Sequence
{
  tts_interfaces__srv__Polly_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tts_interfaces__srv__Polly_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TTS_INTERFACES__SRV__POLLY__STRUCT_H_
