// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tts_interfaces:srv/Polly.idl
// generated code does not contain a copyright notice

#ifndef TTS_INTERFACES__SRV__POLLY__STRUCT_HPP_
#define TTS_INTERFACES__SRV__POLLY__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__tts_interfaces__srv__Polly_Request __attribute__((deprecated))
#else
# define DEPRECATED__tts_interfaces__srv__Polly_Request __declspec(deprecated)
#endif

namespace tts_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Polly_Request_
{
  using Type = Polly_Request_<ContainerAllocator>;

  explicit Polly_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->polly_action = "";
      this->text = "";
      this->text_type = "";
      this->language_code = "";
      this->voice_id = "";
      this->output_format = "";
      this->output_path = "";
      this->sample_rate = "";
      this->lexicon_content = "";
      this->lexicon_name = "";
      this->max_results = 0ul;
      this->next_token = "";
      this->sns_topic_arn = "";
      this->task_id = "";
      this->task_status = "";
      this->output_s3_bucket_name = "";
      this->output_s3_key_prefix = "";
      this->include_additional_language_codes = false;
    }
  }

  explicit Polly_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : polly_action(_alloc),
    text(_alloc),
    text_type(_alloc),
    language_code(_alloc),
    voice_id(_alloc),
    output_format(_alloc),
    output_path(_alloc),
    sample_rate(_alloc),
    lexicon_content(_alloc),
    lexicon_name(_alloc),
    next_token(_alloc),
    sns_topic_arn(_alloc),
    task_id(_alloc),
    task_status(_alloc),
    output_s3_bucket_name(_alloc),
    output_s3_key_prefix(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->polly_action = "";
      this->text = "";
      this->text_type = "";
      this->language_code = "";
      this->voice_id = "";
      this->output_format = "";
      this->output_path = "";
      this->sample_rate = "";
      this->lexicon_content = "";
      this->lexicon_name = "";
      this->max_results = 0ul;
      this->next_token = "";
      this->sns_topic_arn = "";
      this->task_id = "";
      this->task_status = "";
      this->output_s3_bucket_name = "";
      this->output_s3_key_prefix = "";
      this->include_additional_language_codes = false;
    }
  }

  // field types and members
  using _polly_action_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _polly_action_type polly_action;
  using _text_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _text_type text;
  using _text_type_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _text_type_type text_type;
  using _language_code_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _language_code_type language_code;
  using _voice_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _voice_id_type voice_id;
  using _output_format_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _output_format_type output_format;
  using _output_path_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _output_path_type output_path;
  using _sample_rate_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _sample_rate_type sample_rate;
  using _lexicon_content_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _lexicon_content_type lexicon_content;
  using _lexicon_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _lexicon_name_type lexicon_name;
  using _lexicon_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _lexicon_names_type lexicon_names;
  using _speech_mark_types_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _speech_mark_types_type speech_mark_types;
  using _max_results_type =
    uint32_t;
  _max_results_type max_results;
  using _next_token_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _next_token_type next_token;
  using _sns_topic_arn_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _sns_topic_arn_type sns_topic_arn;
  using _task_id_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _task_id_type task_id;
  using _task_status_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _task_status_type task_status;
  using _output_s3_bucket_name_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _output_s3_bucket_name_type output_s3_bucket_name;
  using _output_s3_key_prefix_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _output_s3_key_prefix_type output_s3_key_prefix;
  using _include_additional_language_codes_type =
    bool;
  _include_additional_language_codes_type include_additional_language_codes;

  // setters for named parameter idiom
  Type & set__polly_action(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->polly_action = _arg;
    return *this;
  }
  Type & set__text(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->text = _arg;
    return *this;
  }
  Type & set__text_type(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->text_type = _arg;
    return *this;
  }
  Type & set__language_code(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->language_code = _arg;
    return *this;
  }
  Type & set__voice_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->voice_id = _arg;
    return *this;
  }
  Type & set__output_format(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->output_format = _arg;
    return *this;
  }
  Type & set__output_path(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->output_path = _arg;
    return *this;
  }
  Type & set__sample_rate(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->sample_rate = _arg;
    return *this;
  }
  Type & set__lexicon_content(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->lexicon_content = _arg;
    return *this;
  }
  Type & set__lexicon_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->lexicon_name = _arg;
    return *this;
  }
  Type & set__lexicon_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->lexicon_names = _arg;
    return *this;
  }
  Type & set__speech_mark_types(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->speech_mark_types = _arg;
    return *this;
  }
  Type & set__max_results(
    const uint32_t & _arg)
  {
    this->max_results = _arg;
    return *this;
  }
  Type & set__next_token(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->next_token = _arg;
    return *this;
  }
  Type & set__sns_topic_arn(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->sns_topic_arn = _arg;
    return *this;
  }
  Type & set__task_id(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->task_id = _arg;
    return *this;
  }
  Type & set__task_status(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->task_status = _arg;
    return *this;
  }
  Type & set__output_s3_bucket_name(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->output_s3_bucket_name = _arg;
    return *this;
  }
  Type & set__output_s3_key_prefix(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->output_s3_key_prefix = _arg;
    return *this;
  }
  Type & set__include_additional_language_codes(
    const bool & _arg)
  {
    this->include_additional_language_codes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tts_interfaces::srv::Polly_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const tts_interfaces::srv::Polly_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Polly_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Polly_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tts_interfaces__srv__Polly_Request
    std::shared_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tts_interfaces__srv__Polly_Request
    std::shared_ptr<tts_interfaces::srv::Polly_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Polly_Request_ & other) const
  {
    if (this->polly_action != other.polly_action) {
      return false;
    }
    if (this->text != other.text) {
      return false;
    }
    if (this->text_type != other.text_type) {
      return false;
    }
    if (this->language_code != other.language_code) {
      return false;
    }
    if (this->voice_id != other.voice_id) {
      return false;
    }
    if (this->output_format != other.output_format) {
      return false;
    }
    if (this->output_path != other.output_path) {
      return false;
    }
    if (this->sample_rate != other.sample_rate) {
      return false;
    }
    if (this->lexicon_content != other.lexicon_content) {
      return false;
    }
    if (this->lexicon_name != other.lexicon_name) {
      return false;
    }
    if (this->lexicon_names != other.lexicon_names) {
      return false;
    }
    if (this->speech_mark_types != other.speech_mark_types) {
      return false;
    }
    if (this->max_results != other.max_results) {
      return false;
    }
    if (this->next_token != other.next_token) {
      return false;
    }
    if (this->sns_topic_arn != other.sns_topic_arn) {
      return false;
    }
    if (this->task_id != other.task_id) {
      return false;
    }
    if (this->task_status != other.task_status) {
      return false;
    }
    if (this->output_s3_bucket_name != other.output_s3_bucket_name) {
      return false;
    }
    if (this->output_s3_key_prefix != other.output_s3_key_prefix) {
      return false;
    }
    if (this->include_additional_language_codes != other.include_additional_language_codes) {
      return false;
    }
    return true;
  }
  bool operator!=(const Polly_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Polly_Request_

// alias to use template instance with default allocator
using Polly_Request =
  tts_interfaces::srv::Polly_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tts_interfaces

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__tts_interfaces__srv__Polly_Response __attribute__((deprecated))
#else
# define DEPRECATED__tts_interfaces__srv__Polly_Response __declspec(deprecated)
#endif

namespace tts_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct Polly_Response_
{
  using Type = Polly_Response_<ContainerAllocator>;

  explicit Polly_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
    }
  }

  explicit Polly_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : result(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = "";
    }
  }

  // field types and members
  using _result_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__result(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tts_interfaces::srv::Polly_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const tts_interfaces::srv::Polly_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Polly_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tts_interfaces::srv::Polly_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tts_interfaces__srv__Polly_Response
    std::shared_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tts_interfaces__srv__Polly_Response
    std::shared_ptr<tts_interfaces::srv::Polly_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Polly_Response_ & other) const
  {
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const Polly_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Polly_Response_

// alias to use template instance with default allocator
using Polly_Response =
  tts_interfaces::srv::Polly_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace tts_interfaces

namespace tts_interfaces
{

namespace srv
{

struct Polly
{
  using Request = tts_interfaces::srv::Polly_Request;
  using Response = tts_interfaces::srv::Polly_Response;
};

}  // namespace srv

}  // namespace tts_interfaces

#endif  // TTS_INTERFACES__SRV__POLLY__STRUCT_HPP_
