#ifndef _H_2F8E907F0D45C40F60B56982C3F722BD_Polly__H_
#define _H_2F8E907F0D45C40F60B56982C3F722BD_Polly__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace tts_interfaces
{
    namespace srv
    {
        namespace dds_
        {
            struct  Polly_Request_
            {
                struct _lexicon_names__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _lexicon_names__seq_uniq_ > _lexicon_names__seq;
                typedef DDS_DCPSUStrSeq_var< _lexicon_names__seq > _lexicon_names__seq_var;
                typedef DDS_DCPSUStrSeq_out< _lexicon_names__seq > _lexicon_names__seq_out;
                struct _speech_mark_types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _speech_mark_types__seq_uniq_ > _speech_mark_types__seq;
                typedef DDS_DCPSUStrSeq_var< _speech_mark_types__seq > _speech_mark_types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _speech_mark_types__seq > _speech_mark_types__seq_out;
                ::DDS::String_mgr polly_action_;
                ::DDS::String_mgr text_;
                ::DDS::String_mgr text_type_;
                ::DDS::String_mgr language_code_;
                ::DDS::String_mgr voice_id_;
                ::DDS::String_mgr output_format_;
                ::DDS::String_mgr output_path_;
                ::DDS::String_mgr sample_rate_;
                ::DDS::String_mgr lexicon_content_;
                ::DDS::String_mgr lexicon_name_;
                _lexicon_names__seq lexicon_names_;
                _speech_mark_types__seq speech_mark_types_;
                ::DDS::ULong max_results_;
                ::DDS::String_mgr next_token_;
                ::DDS::String_mgr sns_topic_arn_;
                ::DDS::String_mgr task_id_;
                ::DDS::String_mgr task_status_;
                ::DDS::String_mgr output_s3_bucket_name_;
                ::DDS::String_mgr output_s3_key_prefix_;
                ::DDS::Boolean include_additional_language_codes_;
            };

            typedef DDS_DCPSStruct_var<Polly_Request_> Polly_Request__var;
            typedef DDS_DCPSStruct_out < Polly_Request_> Polly_Request__out;

            struct  Polly_Response_
            {
                ::DDS::String_mgr result_;
            };

            typedef DDS_DCPSStruct_var<Polly_Response_> Polly_Response__var;
            typedef DDS_DCPSStruct_out < Polly_Response_> Polly_Response__out;

            struct  Sample_Polly_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::tts_interfaces::srv::dds_::Polly_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Polly_Request_> Sample_Polly_Request__var;
            typedef DDS_DCPSStruct_out < Sample_Polly_Request_> Sample_Polly_Request__out;

            struct  Sample_Polly_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::tts_interfaces::srv::dds_::Polly_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Polly_Response_> Sample_Polly_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Polly_Response_> Sample_Polly_Response__out;

        }

    }

}

#endif /* _H_2F8E907F0D45C40F60B56982C3F722BD_Polly__H_ */
