#ifndef H_2F8E907F0D45C40F60B56982C3F722BD_Polly_SPLTYPES_H
#define H_2F8E907F0D45C40F60B56982C3F722BD_Polly_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Polly_.h"


extern c_metaObject __Polly__tts_interfaces__load (c_base base);

extern c_metaObject __Polly__tts_interfaces_srv__load (c_base base);

extern c_metaObject __Polly__tts_interfaces_srv_dds___load (c_base base);

extern const char *tts_interfaces_srv_dds__Polly_Request__metaDescriptor[];
extern const int tts_interfaces_srv_dds__Polly_Request__metaDescriptorArrLength;
extern const int tts_interfaces_srv_dds__Polly_Request__metaDescriptorLength;
extern c_metaObject __tts_interfaces_srv_dds__Polly_Request___load (c_base base);
struct _tts_interfaces_srv_dds__Polly_Request_ ;
extern  v_copyin_result __tts_interfaces_srv_dds__Polly_Request___copyIn(c_base base, const struct tts_interfaces::srv::dds_::Polly_Request_ *from, struct _tts_interfaces_srv_dds__Polly_Request_ *to);
extern  void __tts_interfaces_srv_dds__Polly_Request___copyOut(const void *_from, void *_to);
struct _tts_interfaces_srv_dds__Polly_Request_ {
    c_string polly_action_;
    c_string text_;
    c_string text_type_;
    c_string language_code_;
    c_string voice_id_;
    c_string output_format_;
    c_string output_path_;
    c_string sample_rate_;
    c_string lexicon_content_;
    c_string lexicon_name_;
    c_sequence lexicon_names_;
    c_sequence speech_mark_types_;
    c_ulong max_results_;
    c_string next_token_;
    c_string sns_topic_arn_;
    c_string task_id_;
    c_string task_status_;
    c_string output_s3_bucket_name_;
    c_string output_s3_key_prefix_;
    c_bool include_additional_language_codes_;
};

extern const char *tts_interfaces_srv_dds__Polly_Response__metaDescriptor[];
extern const int tts_interfaces_srv_dds__Polly_Response__metaDescriptorArrLength;
extern const int tts_interfaces_srv_dds__Polly_Response__metaDescriptorLength;
extern c_metaObject __tts_interfaces_srv_dds__Polly_Response___load (c_base base);
struct _tts_interfaces_srv_dds__Polly_Response_ ;
extern  v_copyin_result __tts_interfaces_srv_dds__Polly_Response___copyIn(c_base base, const struct tts_interfaces::srv::dds_::Polly_Response_ *from, struct _tts_interfaces_srv_dds__Polly_Response_ *to);
extern  void __tts_interfaces_srv_dds__Polly_Response___copyOut(const void *_from, void *_to);
struct _tts_interfaces_srv_dds__Polly_Response_ {
    c_string result_;
};

extern const char *tts_interfaces_srv_dds__Sample_Polly_Request__metaDescriptor[];
extern const int tts_interfaces_srv_dds__Sample_Polly_Request__metaDescriptorArrLength;
extern const int tts_interfaces_srv_dds__Sample_Polly_Request__metaDescriptorLength;
extern c_metaObject __tts_interfaces_srv_dds__Sample_Polly_Request___load (c_base base);
struct _tts_interfaces_srv_dds__Sample_Polly_Request_ ;
extern  v_copyin_result __tts_interfaces_srv_dds__Sample_Polly_Request___copyIn(c_base base, const struct tts_interfaces::srv::dds_::Sample_Polly_Request_ *from, struct _tts_interfaces_srv_dds__Sample_Polly_Request_ *to);
extern  void __tts_interfaces_srv_dds__Sample_Polly_Request___copyOut(const void *_from, void *_to);
struct _tts_interfaces_srv_dds__Sample_Polly_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _tts_interfaces_srv_dds__Polly_Request_ request_;
};

extern const char *tts_interfaces_srv_dds__Sample_Polly_Response__metaDescriptor[];
extern const int tts_interfaces_srv_dds__Sample_Polly_Response__metaDescriptorArrLength;
extern const int tts_interfaces_srv_dds__Sample_Polly_Response__metaDescriptorLength;
extern c_metaObject __tts_interfaces_srv_dds__Sample_Polly_Response___load (c_base base);
struct _tts_interfaces_srv_dds__Sample_Polly_Response_ ;
extern  v_copyin_result __tts_interfaces_srv_dds__Sample_Polly_Response___copyIn(c_base base, const struct tts_interfaces::srv::dds_::Sample_Polly_Response_ *from, struct _tts_interfaces_srv_dds__Sample_Polly_Response_ *to);
extern  void __tts_interfaces_srv_dds__Sample_Polly_Response___copyOut(const void *_from, void *_to);
struct _tts_interfaces_srv_dds__Sample_Polly_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _tts_interfaces_srv_dds__Polly_Response_ response_;
};

#undef OS_API
#endif
