// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tts_interfaces:srv/Polly.idl
// generated code does not contain a copyright notice
#include "tts_interfaces/srv/polly__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `polly_action`
// Member `text`
// Member `text_type`
// Member `language_code`
// Member `voice_id`
// Member `output_format`
// Member `output_path`
// Member `sample_rate`
// Member `lexicon_content`
// Member `lexicon_name`
// Member `lexicon_names`
// Member `speech_mark_types`
// Member `next_token`
// Member `sns_topic_arn`
// Member `task_id`
// Member `task_status`
// Member `output_s3_bucket_name`
// Member `output_s3_key_prefix`
#include "rosidl_generator_c/string_functions.h"

bool
tts_interfaces__srv__Polly_Request__init(tts_interfaces__srv__Polly_Request * msg)
{
  if (!msg) {
    return false;
  }
  // polly_action
  if (!rosidl_generator_c__String__init(&msg->polly_action)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // text
  if (!rosidl_generator_c__String__init(&msg->text)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // text_type
  if (!rosidl_generator_c__String__init(&msg->text_type)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // language_code
  if (!rosidl_generator_c__String__init(&msg->language_code)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // voice_id
  if (!rosidl_generator_c__String__init(&msg->voice_id)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // output_format
  if (!rosidl_generator_c__String__init(&msg->output_format)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // output_path
  if (!rosidl_generator_c__String__init(&msg->output_path)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // sample_rate
  if (!rosidl_generator_c__String__init(&msg->sample_rate)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // lexicon_content
  if (!rosidl_generator_c__String__init(&msg->lexicon_content)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // lexicon_name
  if (!rosidl_generator_c__String__init(&msg->lexicon_name)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // lexicon_names
  if (!rosidl_generator_c__String__Sequence__init(&msg->lexicon_names, 0)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // speech_mark_types
  if (!rosidl_generator_c__String__Sequence__init(&msg->speech_mark_types, 0)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // max_results
  // next_token
  if (!rosidl_generator_c__String__init(&msg->next_token)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // sns_topic_arn
  if (!rosidl_generator_c__String__init(&msg->sns_topic_arn)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // task_id
  if (!rosidl_generator_c__String__init(&msg->task_id)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // task_status
  if (!rosidl_generator_c__String__init(&msg->task_status)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // output_s3_bucket_name
  if (!rosidl_generator_c__String__init(&msg->output_s3_bucket_name)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // output_s3_key_prefix
  if (!rosidl_generator_c__String__init(&msg->output_s3_key_prefix)) {
    tts_interfaces__srv__Polly_Request__fini(msg);
    return false;
  }
  // include_additional_language_codes
  return true;
}

void
tts_interfaces__srv__Polly_Request__fini(tts_interfaces__srv__Polly_Request * msg)
{
  if (!msg) {
    return;
  }
  // polly_action
  rosidl_generator_c__String__fini(&msg->polly_action);
  // text
  rosidl_generator_c__String__fini(&msg->text);
  // text_type
  rosidl_generator_c__String__fini(&msg->text_type);
  // language_code
  rosidl_generator_c__String__fini(&msg->language_code);
  // voice_id
  rosidl_generator_c__String__fini(&msg->voice_id);
  // output_format
  rosidl_generator_c__String__fini(&msg->output_format);
  // output_path
  rosidl_generator_c__String__fini(&msg->output_path);
  // sample_rate
  rosidl_generator_c__String__fini(&msg->sample_rate);
  // lexicon_content
  rosidl_generator_c__String__fini(&msg->lexicon_content);
  // lexicon_name
  rosidl_generator_c__String__fini(&msg->lexicon_name);
  // lexicon_names
  rosidl_generator_c__String__Sequence__fini(&msg->lexicon_names);
  // speech_mark_types
  rosidl_generator_c__String__Sequence__fini(&msg->speech_mark_types);
  // max_results
  // next_token
  rosidl_generator_c__String__fini(&msg->next_token);
  // sns_topic_arn
  rosidl_generator_c__String__fini(&msg->sns_topic_arn);
  // task_id
  rosidl_generator_c__String__fini(&msg->task_id);
  // task_status
  rosidl_generator_c__String__fini(&msg->task_status);
  // output_s3_bucket_name
  rosidl_generator_c__String__fini(&msg->output_s3_bucket_name);
  // output_s3_key_prefix
  rosidl_generator_c__String__fini(&msg->output_s3_key_prefix);
  // include_additional_language_codes
}

tts_interfaces__srv__Polly_Request *
tts_interfaces__srv__Polly_Request__create()
{
  tts_interfaces__srv__Polly_Request * msg = (tts_interfaces__srv__Polly_Request *)malloc(sizeof(tts_interfaces__srv__Polly_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tts_interfaces__srv__Polly_Request));
  bool success = tts_interfaces__srv__Polly_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
tts_interfaces__srv__Polly_Request__destroy(tts_interfaces__srv__Polly_Request * msg)
{
  if (msg) {
    tts_interfaces__srv__Polly_Request__fini(msg);
  }
  free(msg);
}


bool
tts_interfaces__srv__Polly_Request__Sequence__init(tts_interfaces__srv__Polly_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  tts_interfaces__srv__Polly_Request * data = NULL;
  if (size) {
    data = (tts_interfaces__srv__Polly_Request *)calloc(size, sizeof(tts_interfaces__srv__Polly_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tts_interfaces__srv__Polly_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tts_interfaces__srv__Polly_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tts_interfaces__srv__Polly_Request__Sequence__fini(tts_interfaces__srv__Polly_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tts_interfaces__srv__Polly_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tts_interfaces__srv__Polly_Request__Sequence *
tts_interfaces__srv__Polly_Request__Sequence__create(size_t size)
{
  tts_interfaces__srv__Polly_Request__Sequence * array = (tts_interfaces__srv__Polly_Request__Sequence *)malloc(sizeof(tts_interfaces__srv__Polly_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = tts_interfaces__srv__Polly_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
tts_interfaces__srv__Polly_Request__Sequence__destroy(tts_interfaces__srv__Polly_Request__Sequence * array)
{
  if (array) {
    tts_interfaces__srv__Polly_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `result`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
tts_interfaces__srv__Polly_Response__init(tts_interfaces__srv__Polly_Response * msg)
{
  if (!msg) {
    return false;
  }
  // result
  if (!rosidl_generator_c__String__init(&msg->result)) {
    tts_interfaces__srv__Polly_Response__fini(msg);
    return false;
  }
  return true;
}

void
tts_interfaces__srv__Polly_Response__fini(tts_interfaces__srv__Polly_Response * msg)
{
  if (!msg) {
    return;
  }
  // result
  rosidl_generator_c__String__fini(&msg->result);
}

tts_interfaces__srv__Polly_Response *
tts_interfaces__srv__Polly_Response__create()
{
  tts_interfaces__srv__Polly_Response * msg = (tts_interfaces__srv__Polly_Response *)malloc(sizeof(tts_interfaces__srv__Polly_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tts_interfaces__srv__Polly_Response));
  bool success = tts_interfaces__srv__Polly_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
tts_interfaces__srv__Polly_Response__destroy(tts_interfaces__srv__Polly_Response * msg)
{
  if (msg) {
    tts_interfaces__srv__Polly_Response__fini(msg);
  }
  free(msg);
}


bool
tts_interfaces__srv__Polly_Response__Sequence__init(tts_interfaces__srv__Polly_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  tts_interfaces__srv__Polly_Response * data = NULL;
  if (size) {
    data = (tts_interfaces__srv__Polly_Response *)calloc(size, sizeof(tts_interfaces__srv__Polly_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tts_interfaces__srv__Polly_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tts_interfaces__srv__Polly_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tts_interfaces__srv__Polly_Response__Sequence__fini(tts_interfaces__srv__Polly_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tts_interfaces__srv__Polly_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tts_interfaces__srv__Polly_Response__Sequence *
tts_interfaces__srv__Polly_Response__Sequence__create(size_t size)
{
  tts_interfaces__srv__Polly_Response__Sequence * array = (tts_interfaces__srv__Polly_Response__Sequence *)malloc(sizeof(tts_interfaces__srv__Polly_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = tts_interfaces__srv__Polly_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
tts_interfaces__srv__Polly_Response__Sequence__destroy(tts_interfaces__srv__Polly_Response__Sequence * array)
{
  if (array) {
    tts_interfaces__srv__Polly_Response__Sequence__fini(array);
  }
  free(array);
}
