// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tts_interfaces:srv/Synthesizer.idl
// generated code does not contain a copyright notice
#include "tts_interfaces/srv/synthesizer__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `text`
// Member `metadata`
#include "rosidl_generator_c/string_functions.h"

bool
tts_interfaces__srv__Synthesizer_Request__init(tts_interfaces__srv__Synthesizer_Request * msg)
{
  if (!msg) {
    return false;
  }
  // text
  if (!rosidl_generator_c__String__init(&msg->text)) {
    tts_interfaces__srv__Synthesizer_Request__fini(msg);
    return false;
  }
  // metadata
  if (!rosidl_generator_c__String__init(&msg->metadata)) {
    tts_interfaces__srv__Synthesizer_Request__fini(msg);
    return false;
  }
  return true;
}

void
tts_interfaces__srv__Synthesizer_Request__fini(tts_interfaces__srv__Synthesizer_Request * msg)
{
  if (!msg) {
    return;
  }
  // text
  rosidl_generator_c__String__fini(&msg->text);
  // metadata
  rosidl_generator_c__String__fini(&msg->metadata);
}

tts_interfaces__srv__Synthesizer_Request *
tts_interfaces__srv__Synthesizer_Request__create()
{
  tts_interfaces__srv__Synthesizer_Request * msg = (tts_interfaces__srv__Synthesizer_Request *)malloc(sizeof(tts_interfaces__srv__Synthesizer_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tts_interfaces__srv__Synthesizer_Request));
  bool success = tts_interfaces__srv__Synthesizer_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
tts_interfaces__srv__Synthesizer_Request__destroy(tts_interfaces__srv__Synthesizer_Request * msg)
{
  if (msg) {
    tts_interfaces__srv__Synthesizer_Request__fini(msg);
  }
  free(msg);
}


bool
tts_interfaces__srv__Synthesizer_Request__Sequence__init(tts_interfaces__srv__Synthesizer_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  tts_interfaces__srv__Synthesizer_Request * data = NULL;
  if (size) {
    data = (tts_interfaces__srv__Synthesizer_Request *)calloc(size, sizeof(tts_interfaces__srv__Synthesizer_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tts_interfaces__srv__Synthesizer_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tts_interfaces__srv__Synthesizer_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tts_interfaces__srv__Synthesizer_Request__Sequence__fini(tts_interfaces__srv__Synthesizer_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tts_interfaces__srv__Synthesizer_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tts_interfaces__srv__Synthesizer_Request__Sequence *
tts_interfaces__srv__Synthesizer_Request__Sequence__create(size_t size)
{
  tts_interfaces__srv__Synthesizer_Request__Sequence * array = (tts_interfaces__srv__Synthesizer_Request__Sequence *)malloc(sizeof(tts_interfaces__srv__Synthesizer_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = tts_interfaces__srv__Synthesizer_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
tts_interfaces__srv__Synthesizer_Request__Sequence__destroy(tts_interfaces__srv__Synthesizer_Request__Sequence * array)
{
  if (array) {
    tts_interfaces__srv__Synthesizer_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `result`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
tts_interfaces__srv__Synthesizer_Response__init(tts_interfaces__srv__Synthesizer_Response * msg)
{
  if (!msg) {
    return false;
  }
  // result
  if (!rosidl_generator_c__String__init(&msg->result)) {
    tts_interfaces__srv__Synthesizer_Response__fini(msg);
    return false;
  }
  return true;
}

void
tts_interfaces__srv__Synthesizer_Response__fini(tts_interfaces__srv__Synthesizer_Response * msg)
{
  if (!msg) {
    return;
  }
  // result
  rosidl_generator_c__String__fini(&msg->result);
}

tts_interfaces__srv__Synthesizer_Response *
tts_interfaces__srv__Synthesizer_Response__create()
{
  tts_interfaces__srv__Synthesizer_Response * msg = (tts_interfaces__srv__Synthesizer_Response *)malloc(sizeof(tts_interfaces__srv__Synthesizer_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tts_interfaces__srv__Synthesizer_Response));
  bool success = tts_interfaces__srv__Synthesizer_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
tts_interfaces__srv__Synthesizer_Response__destroy(tts_interfaces__srv__Synthesizer_Response * msg)
{
  if (msg) {
    tts_interfaces__srv__Synthesizer_Response__fini(msg);
  }
  free(msg);
}


bool
tts_interfaces__srv__Synthesizer_Response__Sequence__init(tts_interfaces__srv__Synthesizer_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  tts_interfaces__srv__Synthesizer_Response * data = NULL;
  if (size) {
    data = (tts_interfaces__srv__Synthesizer_Response *)calloc(size, sizeof(tts_interfaces__srv__Synthesizer_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tts_interfaces__srv__Synthesizer_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tts_interfaces__srv__Synthesizer_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tts_interfaces__srv__Synthesizer_Response__Sequence__fini(tts_interfaces__srv__Synthesizer_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tts_interfaces__srv__Synthesizer_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tts_interfaces__srv__Synthesizer_Response__Sequence *
tts_interfaces__srv__Synthesizer_Response__Sequence__create(size_t size)
{
  tts_interfaces__srv__Synthesizer_Response__Sequence * array = (tts_interfaces__srv__Synthesizer_Response__Sequence *)malloc(sizeof(tts_interfaces__srv__Synthesizer_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = tts_interfaces__srv__Synthesizer_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
tts_interfaces__srv__Synthesizer_Response__Sequence__destroy(tts_interfaces__srv__Synthesizer_Response__Sequence * array)
{
  if (array) {
    tts_interfaces__srv__Synthesizer_Response__Sequence__fini(array);
  }
  free(array);
}
